/*---------------------------------------------------------------------------*\
| =========                 |                                                 |
| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |
|  \\    /   O peration     | Version:  1.5                                   |
|   \\  /    A nd           | Web:      http://www.openfoam.org               |
|    \\/     M anipulation  |                                                 |
\*---------------------------------------------------------------------------*/

FoamFile
{
    version         2.0;
    format          ascii;
    class           dictionary;
    object          blockMeshDict;
}

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

//Parametrized test case
//Run using:
//m4 -P blockMeshDict.m4 > blockMeshDict

convertToMeters 0.1;

//m4 definitions:
m4_changecom(//)m4_changequote([,])
m4_define(calc, [m4_esyscmd(perl -e 'use Math::Trig; printf ($1)')])
m4_define(VCOUNT, 0)
m4_define(vlabel, [[// ]Vertex $1 = VCOUNT m4_define($1, VCOUNT)m4_define([VCOUNT], m4_incr(VCOUNT))])

//Mathematical constants:
m4_define(pi, 3.1415926536)

//Parameters:
m4_define(OpAngRot, 0)
m4_define(closeAngRot, 30)
m4_define(OpAngStat, 0)
m4_define(closeAngStat, 30)
m4_define(ZIn, 0)
m4_define(ZUt, 1)
m4_define(rIn, 1)
m4_define(rC, 6)
m4_define(rUt, 11)
m4_define(rRotIn, 2.5) 
m4_define(rRotC, 4) 
m4_define(AngRot, 1.9102)
m4_define(rRotUt, 5.8)
m4_define(rStatIn, 6.2)
m4_define(rStatC, 8)
m4_define(AngStat, 1.4325)
m4_define(rStatUt, 9.5)
m4_define(rNumberOfCellsInner, 40) 
m4_define(tNumberOfCellsInner, 40) 
m4_define(zNumberOfCellsInner, 1)
m4_define(rGradingInner, 1)
m4_define(tGradingInner, 1)
m4_define(zGradingInner, 1)
m4_define(rNumberOfCellsOuter, 40) 
m4_define(tNumberOfCellsOuter, 40) 
m4_define(zNumberOfCellsOuter, 1)
m4_define(rGradingOuter, 1)
m4_define(tGradingOuter, 1)
m4_define(zGradingOuter, 1)


vertices
(

(0 0 0) vlabel(I0)
(calc(rIn*cos(OpAngRot*pi/180)) calc(rIn*sin(OpAngRot*pi/180)) ZIn) vlabel(I1)
(calc(rRotIn*cos(OpAngRot*pi/180)) calc(rRotIn*sin(OpAngRot*pi/180)) ZIn) vlabel(I2)
(calc(rRotC*cos(AngRot*pi/180)) calc(rRotC*sin(AngRot*pi/180)) ZIn) vlabel(I3)
(calc(rRotUt*cos(OpAngRot*pi/180)) calc(rRotUt*sin(OpAngRot*pi/180)) ZIn) vlabel(I4)
(calc(rC*cos(OpAngRot*pi/180)) calc(rC*sin(OpAngRot*pi/180)) ZIn) vlabel(I5)
(calc(rStatIn*cos(OpAngStat*pi/180)) calc(rStatIn*sin(OpAngStat*pi/180)) ZIn) vlabel(I6)
(calc(rStatC*cos(AngStat*pi/180)) calc(rStatC*sin(AngStat*pi/180)) ZIn) vlabel(I7)
(calc(rStatUt*cos(OpAngStat*pi/180)) calc(rStatUt*sin(OpAngStat*pi/180)) ZIn) vlabel(I8)
(calc(rUt*cos(OpAngStat*pi/180)) calc(rUt*sin(OpAngStat*pi/180)) ZIn) vlabel(I9)

(calc(rIn*cos((closeAngRot-OpAngRot)/2*pi/180)) calc(rIn*sin((closeAngRot-OpAngRot)/2*pi/180)) ZIn) vlabel(I10)
(calc(rRotIn*cos((closeAngRot-OpAngRot)/2*pi/180)) calc(rRotIn*sin((closeAngRot-OpAngRot)/2*pi/180)) ZIn) vlabel(I11)
(calc(rRotC*cos((closeAngRot-OpAngRot)/2*pi/180)) calc(rRotC*sin((closeAngRot-OpAngRot)/2*pi/180)) ZIn) vlabel(I12)
(calc(rRotUt*cos((closeAngRot-OpAngRot)/2*pi/180)) calc(rRotUt*sin((closeAngRot-OpAngRot)/2*pi/180)) ZIn) vlabel(I13)
(calc(rC*cos((closeAngRot-OpAngRot)/2*pi/180)) calc(rC*sin((closeAngRot-OpAngRot)/2*pi/180)) ZIn) vlabel(I14)
(calc(rStatIn*cos((closeAngStat-OpAngStat)/2*pi/180)) calc(rStatIn*sin((closeAngStat-OpAngStat)/2*pi/180)) ZIn) vlabel(I15)
(calc(rStatC*cos((closeAngStat-OpAngStat)/2*pi/180)) calc(rStatC*sin((closeAngStat-OpAngStat)/2*pi/180)) ZIn) vlabel(I16)
(calc(rStatUt*cos((closeAngStat-OpAngStat)/2*pi/180)) calc(rStatUt*sin((closeAngStat-OpAngStat)/2*pi/180)) ZIn) vlabel(I17)
(calc(rUt*cos((closeAngStat-OpAngStat)/2*pi/180)) calc(rUt*sin((closeAngStat-OpAngStat)/2*pi/180)) ZIn) vlabel(I18)

(calc(rIn*cos(closeAngRot*pi/180)) calc(rIn*sin(closeAngRot*pi/180)) ZIn) vlabel(I19)
(calc(rRotIn*cos(closeAngRot*pi/180)) calc(rRotIn*sin(closeAngRot*pi/180)) ZIn) vlabel(I20)
(calc(rRotC*cos((closeAngRot-AngRot)*pi/180)) calc(rRotC*sin((closeAngRot-AngRot)*pi/180)) ZIn) vlabel(I21)
(calc(rRotUt*cos(closeAngRot*pi/180)) calc(rRotUt*sin(closeAngRot*pi/180)) ZIn) vlabel(I22)
(calc(rC*cos(closeAngRot*pi/180)) calc(rC*sin(closeAngRot*pi/180)) ZIn) vlabel(I23)
(calc(rStatIn*cos(closeAngStat*pi/180)) calc(rStatIn*sin(closeAngStat*pi/180)) ZIn) vlabel(I24)
(calc(rStatC*cos((closeAngStat-AngStat)*pi/180)) calc(rStatC*sin((closeAngStat-AngStat)*pi/180)) ZIn) vlabel(I25)
(calc(rStatUt*cos(closeAngStat*pi/180)) calc(rStatUt*sin(closeAngStat*pi/180)) ZIn) vlabel(I26)
(calc(rUt*cos(closeAngStat*pi/180)) calc(rUt*sin(closeAngStat*pi/180)) ZIn) vlabel(I27)



(calc(rIn*cos(OpAngRot*pi/180)) calc(rIn*sin(OpAngRot*pi/180)) ZUt) vlabel(I28)
(calc(rRotIn*cos(OpAngRot*pi/180)) calc(rRotIn*sin(OpAngRot*pi/180)) ZUt) vlabel(I29)
(calc(rRotC*cos(AngRot*pi/180)) calc(rRotC*sin(AngRot*pi/180)) ZUt) vlabel(I30)
(calc(rRotUt*cos(OpAngRot*pi/180)) calc(rRotUt*sin(OpAngRot*pi/180)) ZUt) vlabel(I31)
(calc(rC*cos(OpAngRot*pi/180)) calc(rC*sin(OpAngRot*pi/180)) ZUt) vlabel(I32)
(calc(rStatIn*cos(OpAngStat*pi/180)) calc(rStatIn*sin(OpAngStat*pi/180)) ZUt) vlabel(I33)
(calc(rStatC*cos(AngStat*pi/180)) calc(rStatC*sin(AngStat*pi/180)) ZUt) vlabel(I34)
(calc(rStatUt*cos(OpAngStat*pi/180)) calc(rStatUt*sin(OpAngStat*pi/180)) ZUt) vlabel(I35)
(calc(rUt*cos(OpAngStat*pi/180)) calc(rUt*sin(OpAngStat*pi/180)) ZUt) vlabel(I36)

(calc(rIn*cos((closeAngRot-OpAngRot)/2*pi/180)) calc(rIn*sin((closeAngRot-OpAngRot)/2*pi/180)) ZUt) vlabel(I37)
(calc(rRotIn*cos((closeAngRot-OpAngRot)/2*pi/180)) calc(rRotIn*sin((closeAngRot-OpAngRot)/2*pi/180)) ZUt) vlabel(I38)
(calc(rRotC*cos((closeAngRot-OpAngRot)/2*pi/180)) calc(rRotC*sin((closeAngRot-OpAngRot)/2*pi/180)) ZUt) vlabel(I39)
(calc(rRotUt*cos((closeAngRot-OpAngRot)/2*pi/180)) calc(rRotUt*sin((closeAngRot-OpAngRot)/2*pi/180)) ZUt) vlabel(I40)
(calc(rC*cos((closeAngRot-OpAngRot)/2*pi/180)) calc(rC*sin((closeAngRot-OpAngRot)/2*pi/180)) ZUt) vlabel(I41)
(calc(rStatIn*cos((closeAngStat-OpAngStat)/2*pi/180)) calc(rStatIn*sin((closeAngStat-OpAngStat)/2*pi/180)) ZUt) vlabel(I42)
(calc(rStatC*cos((closeAngStat-OpAngStat)/2*pi/180)) calc(rStatC*sin((closeAngStat-OpAngStat)/2*pi/180)) ZUt) vlabel(I43)
(calc(rStatUt*cos((closeAngStat-OpAngStat)/2*pi/180)) calc(rStatUt*sin((closeAngStat-OpAngStat)/2*pi/180)) ZUt) vlabel(I44)
(calc(rUt*cos((closeAngStat-OpAngStat)/2*pi/180)) calc(rUt*sin((closeAngStat-OpAngStat)/2*pi/180)) ZUt) vlabel(I45)

(calc(rIn*cos(closeAngRot*pi/180)) calc(rIn*sin(closeAngRot*pi/180)) ZUt) vlabel(I46)
(calc(rRotIn*cos(closeAngRot*pi/180)) calc(rRotIn*sin(closeAngRot*pi/180)) ZUt) vlabel(I47)
(calc(rRotC*cos((closeAngRot-AngRot)*pi/180)) calc(rRotC*sin((closeAngRot-AngRot)*pi/180)) ZUt) vlabel(I48)
(calc(rRotUt*cos(closeAngRot*pi/180)) calc(rRotUt*sin(closeAngRot*pi/180)) ZUt) vlabel(I49)
(calc(rC*cos(closeAngRot*pi/180)) calc(rC*sin(closeAngRot*pi/180)) ZUt) vlabel(I50)
(calc(rStatIn*cos(closeAngStat*pi/180)) calc(rStatIn*sin(closeAngStat*pi/180)) ZUt) vlabel(I51)
(calc(rStatC*cos((closeAngStat-AngStat)*pi/180)) calc(rStatC*sin((closeAngStat-AngStat)*pi/180)) ZUt) vlabel(I52)
(calc(rStatUt*cos(closeAngStat*pi/180)) calc(rStatUt*sin(closeAngStat*pi/180)) ZUt) vlabel(I53)
(calc(rUt*cos(closeAngStat*pi/180)) calc(rUt*sin(closeAngStat*pi/180)) ZUt) vlabel(I54)

(calc(rC*cos(OpAngStat*pi/180)) calc(rC*sin(OpAngStat*pi/180)) ZIn) vlabel(I55)
(calc(rC*cos((closeAngStat-OpAngStat)/2*pi/180)) calc(rC*sin((closeAngStat-OpAngStat)/2*pi/180)) ZIn) vlabel(I56)
(calc(rC*cos((closeAngStat-OpAngStat)/2*pi/180)) calc(rC*sin((closeAngStat-OpAngStat)/2*pi/180)) ZUt) vlabel(I57)
(calc(rC*cos(OpAngStat*pi/180)) calc(rC*sin(OpAngStat*pi/180)) ZUt) vlabel(I58)
(calc(rC*cos(closeAngStat*pi/180)) calc(rC*sin(closeAngStat*pi/180)) ZIn) vlabel(I59)
(calc(rC*cos(closeAngStat*pi/180)) calc(rC*sin(closeAngStat*pi/180)) ZUt) vlabel(I60)


);


// Defining blocks:
blocks
(
    hex (I1 I2 I11 I10 I28 I29 I38 I37) rotor (10 10 1)  simpleGrading (1 5 1)           // B1
    hex (I2 I3 I12 I11 I29 I30 I39 I38) rotor (15 10 1)  simpleGrading (1 5 1)           // B2
    hex (I3 I4 I13 I12 I30 I31 I40 I39 ) rotor (15 10 1)  simpleGrading (1 5 1)          // B3
    hex (I4 I5 I14 I13 I31 I32 I41 I40) rotor (3 10 1)  simpleGrading (1 5 1)           // B4
    hex (I55 I6 I15 I56 I58 I33 I42 I57) (3 10 1) simpleGrading (1 5 1)          // B5
    hex (I6 I7 I16 I15 I33 I34 I43 I42) (15 10 1) simpleGrading (1 5 1)         // B6
    hex (I7 I8 I17 I16 I34 I35 I44 I43) (15 10 1) simpleGrading (1 5 1)         // B7
    hex (I8 I9 I18 I17 I35 I36 I45 I44) (10 10 1) simpleGrading (1 5 1)         // B8
    hex (I10 I11 I20 I19 I37 I38 I47 I46) rotor (10 10 1)  simpleGrading (1 0.2 1)       // B9
    hex (I11 I12 I21 I20 I38 I39 I48 I47) rotor (15 10 1)  simpleGrading (1 0.2 1)       // B10
    hex (I12 I13 I22 I21 I39 I40 I49 I48) rotor (15 10 1)  simpleGrading (1 0.2 1)       // B11
    hex (I13 I14 I23 I22 I40 I41 I50 I49) rotor (3 10 1)  simpleGrading (1 0.2 1)        // B12
    hex (I56 I15 I24 I59 I57 I42 I51 I60) (3 10 1) simpleGrading (1 0.2 1)      // B13
    hex (I15 I16 I25 I24 I42 I43 I52 I51) (15 10 1) simpleGrading (1 0.2 1)     // B14
    hex (I16 I17 I26 I25 I43 I44 I53 I52) (15 10 1) simpleGrading (1 0.2 1)     // B15
    hex (I17 I18 I27 I26 I44 I45 I54 I53) (10 10 1) simpleGrading (1 0.2 1)     // B16
);


edges
(
        arc I1 I10 (calc(rIn*cos((closeAngRot-OpAngRot)/4*pi/180))  calc(rIn*sin((closeAngRot-OpAngRot)/4*pi/180)) calc(ZIn))
        arc I28 I37 (calc(rIn*cos((closeAngRot-OpAngRot)/4*pi/180))  calc(rIn*sin((closeAngRot-OpAngRot)/4*pi/180)) calc(ZUt))
        arc I5 I14 (calc(rC*cos((closeAngRot-OpAngRot)/4*pi/180))  calc(rC*sin((closeAngRot-OpAngRot)/4*pi/180)) calc(ZIn))
        arc I32 I41 (calc(rC*cos((closeAngRot-OpAngRot)/4*pi/180))  calc(rC*sin((closeAngRot-OpAngRot)/4*pi/180)) calc(ZUt))
        arc I9 I18 (calc(rUt*cos((closeAngStat-OpAngStat)/4*pi/180))  calc(rUt*sin((closeAngStat-OpAngStat)/4*pi/180)) calc(ZIn))
        arc I36 I45 (calc(rUt*cos((closeAngStat-OpAngStat)/4*pi/180))  calc(rUt*sin((closeAngStat-OpAngStat)/4*pi/180)) calc(ZUt))

        arc I10 I19 (calc(rIn*cos(3*(closeAngRot-OpAngRot)/4*pi/180))  calc(rIn*sin(3*(closeAngRot-OpAngRot)/4*pi/180)) calc(ZIn))
        arc I37 I46 (calc(rIn*cos(3*(closeAngRot-OpAngRot)/4*pi/180))  calc(rIn*sin(3*(closeAngRot-OpAngRot)/4*pi/180)) calc(ZUt))
        arc I14 I23 (calc(rC*cos(3*(closeAngRot-OpAngRot)/4*pi/180))  calc(rC*sin(3*(closeAngRot-OpAngRot)/4*pi/180)) calc(ZIn))
        arc I41 I50 (calc(rC*cos(3*(closeAngRot-OpAngRot)/4*pi/180))  calc(rC*sin(3*(closeAngRot-OpAngRot)/4*pi/180)) calc(ZUt))
        arc I18 I27 (calc(rUt*cos(3*(closeAngStat-OpAngStat)/4*pi/180))  calc(rUt*sin(3*(closeAngStat-OpAngStat)/4*pi/180)) calc(ZIn))
        arc I45 I54 (calc(rUt*cos(3*(closeAngStat-OpAngStat)/4*pi/180))  calc(rUt*sin(3*(closeAngStat-OpAngStat)/4*pi/180)) calc(ZUt))
        

	arc I2 I11 (calc(rRotIn*cos((closeAngRot-OpAngRot)/4*pi/180))  calc(rRotIn*sin((closeAngRot-OpAngRot)/4*pi/180)) calc(ZIn))
        arc I29 I38 (calc(rRotIn*cos((closeAngRot-OpAngRot)/4*pi/180))  calc(rRotIn*sin((closeAngRot-OpAngRot)/4*pi/180)) calc(ZUt))
        arc I3 I12 (calc(rRotC*cos((closeAngRot-OpAngRot)/4*pi/180))  calc(rRotC*sin((closeAngRot-OpAngRot)/4*pi/180)) calc(ZIn))
        arc I30 I39 (calc(rRotC*cos((closeAngRot-OpAngRot)/4*pi/180))  calc(rRotC*sin((closeAngRot-OpAngRot)/4*pi/180)) calc(ZUt))
        arc I4 I13 (calc(rRotUt*cos((closeAngRot-OpAngRot)/4*pi/180))  calc(rRotUt*sin((closeAngRot-OpAngRot)/4*pi/180)) calc(ZIn))
        arc I31 I40 (calc(rRotUt*cos((closeAngRot-OpAngRot)/4*pi/180))  calc(rRotUt*sin((closeAngRot-OpAngRot)/4*pi/180)) calc(ZUt))
        arc I6 I15 (calc(rStatIn*cos((closeAngStat-OpAngStat)/4*pi/180))  calc(rStatIn*sin((closeAngStat-OpAngStat)/4*pi/180)) calc(ZIn))
        arc I33 I42 (calc(rStatIn*cos((closeAngStat-OpAngStat)/4*pi/180))  calc(rStatIn*sin((closeAngStat-OpAngStat)/4*pi/180)) calc(ZUt))
        arc I7 I16 (calc(rStatC*cos((closeAngStat-OpAngStat)/4*pi/180))  calc(rStatC*sin((closeAngStat-OpAngStat)/4*pi/180)) calc(ZIn))
        arc I34 I43 (calc(rStatC*cos((closeAngStat-OpAngStat)/4*pi/180))  calc(rStatC*sin((closeAngStat-OpAngStat)/4*pi/180)) calc(ZUt))
        arc I8 I17 (calc(rStatUt*cos((closeAngStat-OpAngStat)/4*pi/180))  calc(rStatUt*sin((closeAngStat-OpAngStat)/4*pi/180)) calc(ZIn))
        arc I35 I44 (calc(rStatUt*cos((closeAngStat-OpAngStat)/4*pi/180))  calc(rStatUt*sin((closeAngStat-OpAngStat)/4*pi/180)) calc(ZUt))

        arc I20 I11 (calc(rRotIn*cos(3*(closeAngRot-OpAngRot)/4*pi/180))  calc(rRotIn*sin(3*(closeAngRot-OpAngRot)/4*pi/180)) calc(ZIn))
        arc I47 I38 (calc(rRotIn*cos(3*(closeAngRot-OpAngRot)/4*pi/180))  calc(rRotIn*sin(3*(closeAngRot-OpAngRot)/4*pi/180)) calc(ZUt))
        arc I21 I12 (calc(rRotC*cos(3*(closeAngRot-OpAngRot)/4*pi/180))  calc(rRotC*sin(3*(closeAngRot-OpAngRot)/4*pi/180)) calc(ZIn))
        arc I48 I39 (calc(rRotC*cos(3*(closeAngRot-OpAngRot)/4*pi/180))  calc(rRotC*sin(3*(closeAngRot-OpAngRot)/4*pi/180)) calc(ZUt))
        arc I22 I13 (calc(rRotUt*cos(3*(closeAngRot-OpAngRot)/4*pi/180))  calc(rRotUt*sin(3*(closeAngRot-OpAngRot)/4*pi/180)) calc(ZIn))
        arc I49 I40 (calc(rRotUt*cos(3*(closeAngRot-OpAngRot)/4*pi/180))  calc(rRotUt*sin(3*(closeAngRot-OpAngRot)/4*pi/180)) calc(ZUt))
        arc I24 I15 (calc(rStatIn*cos(3*(closeAngStat-OpAngStat)/4*pi/180))  calc(rStatIn*sin(3*(closeAngStat-OpAngStat)/4*pi/180)) calc(ZIn))
        arc I51 I42 (calc(rStatIn*cos(3*(closeAngStat-OpAngStat)/4*pi/180))  calc(rStatIn*sin(3*(closeAngStat-OpAngStat)/4*pi/180)) calc(ZUt))
        arc I25 I16 (calc(rStatC*cos(3*(closeAngStat-OpAngStat)/4*pi/180))  calc(rStatC*sin(3*(closeAngStat-OpAngStat)/4*pi/180)) calc(ZIn))
        arc I52 I43 (calc(rStatC*cos(3*(closeAngStat-OpAngStat)/4*pi/180))  calc(rStatC*sin(3*(closeAngStat-OpAngStat)/4*pi/180)) calc(ZUt))
        arc I26 I17 (calc(rStatUt*cos(3*(closeAngStat-OpAngStat)/4*pi/180))  calc(rStatUt*sin(3*(closeAngStat-OpAngStat)/4*pi/180)) calc(ZIn))
        arc I53 I44 (calc(rStatUt*cos(3*(closeAngStat-OpAngStat)/4*pi/180))  calc(rStatUt*sin(3*(closeAngStat-OpAngStat)/4*pi/180)) calc(ZUt))

        arc I55 I56 (calc(rC*cos((closeAngStat-OpAngStat)/4*pi/180))  calc(rC*sin((closeAngStat-OpAngStat)/4*pi/180)) calc(ZIn))
        arc I58 I57 (calc(rC*cos((closeAngStat-OpAngStat)/4*pi/180))  calc(rC*sin((closeAngStat-OpAngStat)/4*pi/180)) calc(ZUt))
        arc I56 I59 (calc(rC*cos(3*(closeAngStat-OpAngStat)/4*pi/180))  calc(rC*sin(3*(closeAngStat-OpAngStat)/4*pi/180)) calc(ZIn))
        arc I57 I60 (calc(rC*cos(3*(closeAngStat-OpAngStat)/4*pi/180))  calc(rC*sin(3*(closeAngStat-OpAngStat)/4*pi/180)) calc(ZUt))

);


// Defining patches:
patches
(
    wall ROTORBLADES
    (
        (I30 I29 I2 I3)
        (I31 I30 I3 I4)
        (I47 I48 I21 I20)
        (I48 I49 I22 I21)
    )
    wall STATORBLADES
    (
        (I34 I33 I6 I7)
        (I35 I34 I7 I8)
        (I51 I52 I25 I24)
        (I52 I53 I26 I25)
    )
    ggi GGI_INT
    (
        (I14 I41 I32 I5)
        (I23 I50 I41 I14)
    )
    ggi GGI_EXT
    (
        (I55 I58 I57 I56)
        (I56 I57 I60 I59)
    )
    patch INLET
    (
        (I1 I28 I37 I10)
        (I10 I37 I46 I19)
    )
    patch OUTLET
    (
        (I18 I45 I36 I9)
        (I27 I54 I45 I18)
    )
    cyclicGgi ROTOR_CYCLIC_LEFT
    (
      (I19 I46 I47 I20)
      (I22 I49 I50 I23)
    )
    cyclicGgi STATOR_CYCLIC_LEFT
    (
      (I59 I60 I51 I24)
      (I26 I53 I54 I27)
    )
    cyclicGgi ROTOR_CYCLIC_RIGHT
    (
      (I2 I29 I28 I1)
      (I5 I32 I31 I4)
    )
    cyclicGgi STATOR_CYCLIC_RIGHT
    (
      (I6 I33 I58 I55)
      (I9 I36 I35 I8)
    )
    empty ROTOR_TOP_DOWN
    (
        (I38 I29 I30 I39)
        (I11 I12 I3 I2)
        (I10 I11 I2 I1)
        (I37 I28 I29 I38)
        (I39 I30 I31 I40)
        (I12 I13 I4 I3)
        (I13 I14 I5 I4)
        (I40 I31 I32 I41)
        (I19 I20 I11 I10)
        (I20 I21 I12 I11)
        (I21 I22 I13 I12)
        (I22 I23 I14 I13)
        (I46 I37 I38 I47)
        (I47 I38 I39 I48)
        (I48 I39 I40 I49)
        (I49 I40 I41 I50)
    )

    empty STATOR_TOP_DOWN
    (
        (I56 I15 I6 I55)
        (I15 I16 I7 I6)
        (I16 I17 I8 I7)
        (I17 I18 I9 I8)
        (I57 I58 I33 I42)
        (I42 I33 I34 I43)
        (I43 I34 I35 I44)
        (I44 I35 I36 I45)
        (I59 I24 I15 I56)
        (I24 I25 I16 I15)
        (I25 I26 I17 I16)
        (I26 I27 I18 I17)
        (I60 I57 I42 I51)
        (I51 I42 I43 I52)
        (I52 I43 I44 I53)
        (I53 I44 I45 I54)
    )
//    cyclic CYCLIC
//    (
//        (I19 I46 I47 I20)
//        (I22 I49 I50 I23)
//        (I23 I50 I51 I24)
//        (I26 I53 I54 I27)
//        (I2 I29 I28 I1)
 ////       (I5 I32 I31 I4)
//        (I6 I33 I32 I5)
//        (I9 I36 I35 I8)
//     )


);

mergePatchPairs
(
);


// ************************************************************************* //

